﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;

namespace demo.MVC.Models
{
    public class Student
    {
        public int id { get; set; }

        [Required]
        public string name { get; set; }

        public string address { get; set; }

        [Required]
        public int age { get; set; }

        [Required]
        public string standard { get; set; }

        [Required]
        [RegularExpression(@"^(0(?!\.00)|[1-9]\d{0,6})\.\d{2}$", ErrorMessage = "Invalid should be like 79.76")]
        public decimal percent { get; set; }

        [DataType(DataType.DateTime)]
        public DateTime addedOn { get; set; }

        [Required]
        public bool status { get; set; }

        public int pageSize { get; set; }
        public int pageNo { get; set; }
    }
}